<template>
    <div class="wrapper">
        <loading :active.sync="loading" is-full-page></loading>
        <nav-title :title="title" :icon="icon"></nav-title>
        <div class="md-layout">
            <div class="md-layout-item">
                <div class="md-layout mt-3 ">
                    <div class="md-layout-item md-size-20" >
                    </div>
                    <div
                        class="md-layout-item  md-xlarge-size-40 md-large-size-40 md-medium-size-90 md-small-size-95"
                    >
                        <card-recurso id="card"  v-if="resource" :resource="resource">
                            <template slot="button">
                                <star-rating
                                    inactive-color="#4A6274"
                                    active-color="#59A8BA"
                                    @rating-selected="sendVote"
                                    :star-size="starSize"
                                    :show-rating="showRating"
                                    v-model="strarValue"
                                ></star-rating>
                            </template>

                            <template slot="pdf">
                                <pdf-recurso :resource="resource">
                                </pdf-recurso>
                            </template>
                            <template slot="video">
                                <video-recurso
                                    :resource="resource"
                                ></video-recurso>
                            </template>
                        </card-recurso>
                        <div v-else>
                            No exite el recurso
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>
<script>
import axios from "axios";
import CardRecurso from "../../components/Recursos/CardRecurso.vue";
import PdfRecurso from "../../components/Recursos/PdfRecurso.vue";
import VideoRecurso from "../../components/Recursos/VideoRecurso.vue";
import NavTitle from "../../../layout/NavTitle.vue";
export default {
    components: { CardRecurso, VideoRecurso, PdfRecurso, VideoRecurso,NavTitle },
    name: 'resourcedetail',
    data() {
        return {
                        icon: "list",
            title: "Recursos",
            loading: false,
            resourceId: 0,
            loading: false,
            endPoint: "/api/resource",
            resource: {},
            showRating: false,
            starSize: 20,
            strarValue: 0,
            //
            endPointVote: "/api/sendVote"
        };
    },
    computed: {
        user() {
            return this.$auth.watch.data;
        }
    },
    methods: {
        myvote(id) {
            let vote = this.ratings.find(c => c.user_id == id);
            if(vote){
            this.strarValue = vote.total_rating;
            }

        },
        sendVote() {
            if (this.user == null) {
                this.$root.WarnMgs("Es necesario iniciar sesión para votar");
            } else {
                let vote = {
                    resource_id: this.resource.id,
                    rating: this.strarValue
                };
                axios
                    .post(this.endPointVote, vote)
                    .then(response => {
                        if (response && response.data) {
                            this.getResourceById();
                            this.$root.SuccessMgs(response.data.message);
                        }
                    })
                    .catch(error => {
                        console.log("Error en sendVote" + error);
                        this.$root.ErrorMgs("Error a registrar el voto");
                    });
            }
        },
        getResourceById() {
            this.loading = true;
            let uri = `${this.endPoint}/${this.resourceId}`;

            axios
                .get(uri)
                .then(res => {
                    if (res && res.data && res.data && res.data.data) {
                        this.resource = res.data.data;
                        this.ratings = res.data.data.ratings;
                        if(this.use != null){
                            this.myvote(this.user.id); 
                        }
                    }
                })
                .catch(error => {
                    this.resource = null;
                    console.log("Error getResourceById" + error);
                })
                .finally(res => {
                    this.loading = false;
                });
        }
    },
    mounted() {
        this.resourceId = this.$route?.params?.id;

        if (this.resourceId) {
            this.getResourceById();
        }
    }
};
</script>
